#include "common.h"


void scalingSize(unsigned char *in,unsigned char *out,int toSizeW,int toSizeH,int fromSizeW,int fromSizeH)
{
	unsigned char **temp;
	
	float x_scale=(float)toSizeW/(float)fromSizeW;
	float y_scale=(float)toSizeH/(float)fromSizeH;
	
	temp=new unsigned char  *[fromSizeW];
	for(int i=0;i<fromSizeW;i++)
			temp [i]=new unsigned char [fromSizeH];
	//printf("From =%d %d To = %d %d Scale=%f %f\n",fromSizeW,fromSizeH,toSizeW,toSizeH,x_scale,y_scale);
	
	int s_xx,s_yy;
	for(int i=0;i<fromSizeH;i++)
	{
		for(int j=0;j<fromSizeW;j++)
		{
			
			//printf("%d %d\n",j,i);
			temp[j][i]=in[j+i*fromSizeW];
		}
	}
	

	for(int i=0;i<toSizeH;i++)
	{
		for(int j=0;j<toSizeW;j++)
		{
			s_xx=(int)(j/(float)x_scale);
			s_yy=(int)(i/(float)y_scale);
			
			if(s_xx<0)
				s_xx=0;
			if(s_yy<0)
				s_yy=0;
			if(s_xx>=fromSizeW)
				s_xx=toSizeW;
			if(s_yy>=fromSizeH)
				s_yy=toSizeH;

			if(s_xx>=0 && s_yy>=0 && s_xx<fromSizeW && s_yy < fromSizeH){
				//printf("%d %d => %d %d signal=%d \n",j,i,s_xx,s_yy,temp[s_xx][s_yy]);
				out[j+i*toSizeW]=temp[s_xx][s_yy];
			}else {
				printf("Error %d	%d\n",s_xx,s_yy);
			}
		}
	}
	
	//printf("sample %d %d\n",fromSizeW,fromSizeH);
	
	for(int i=0;i<fromSizeW;i++)
	{
		//printf("%d ",i);
		delete [] temp[i];
		
	}

	delete [] temp;
	//exit(0);
	
}

void kaiten(unsigned char *bufmoto,unsigned char *bufout,int SZ_X,float rotation)
{
//http://www.sm.rim.or.jp/~shishido/kaiten.html

	double s;
	s=(2*PI)/(360)*rotation;

	for(int i=0;i<SZ_X*SZ_X;i++)
		bufout[i]=0;

	
	
		
		int xx,yy;

		for (int i=0;i<SZ_X;i++)
			for(int j=0;j<SZ_X;j++) {

			// ]ɑΉ]ÕsNZ߂ 

			
				xx=((j-SZ_X/2)*cos(-s)-(i-SZ_X/2)*sin(-s)+SZ_X/2);
				yy=(j-SZ_X/2)*sin(-s)+(i-SZ_X/2)*cos(-s)+SZ_X/2;

			// ]̃sNZɁAΉ]ÕsNZ` 
				if (xx>=0 && yy>=0 && xx<SZ_X && yy<SZ_X)
					bufout[j+i*SZ_X]=bufmoto[xx+yy*SZ_X];
			}
	
	
}



void CopyArray(unsigned char *in,unsigned char *out,int sz_x,int sz_y){
	for(int i=0;i<sz_x*sz_y;i++){
		out[i]=in[i];
	}
}
void RotateImg(unsigned char *in,unsigned char *out,int sz_x, int sz_y,float rotaiton){
	unsigned char *org;
	unsigned char *rot;
	
	org=new unsigned char[sz_x*sz_x];
	rot=new unsigned char[sz_x*sz_x];
	
	if(sz_x<sz_y){
		printf("Error:Cannnot RotateImgsize\n");
		exit(0);
	}

	for(int i=0;i<sz_x*sz_x;i++){
		org[i]=0;
		rot[i]=0;
	}
	
	for(int j=0;j<sz_x;j++){
		for(int i=0;i<sz_y;i++){
			org[j+(i+(sz_x-sz_y)/2)*sz_x]=in[j+i*sz_x];
		}
	}

	
	kaiten(org,rot,sz_x,rotaiton);
	//u_wtfile(rot,"org2.raw",sz_x*sz_x);
	for(int j=0;j<sz_x;j++){
		for(int i=0;i<sz_y;i++){
				out[j+i*sz_x]=rot[j+(i+(sz_x-sz_y)/2)*sz_x];
		}
	}
	
	delete [] org;
	delete [] rot;
	
}
void CleanEdge(unsigned char *inout,int sz_x, int sz_y,int width){
	int i,j;
	i=0;
	for(int k=0;k<width;k++){
		i=k;
		for(j=0;j<sz_x;j++){
			inout[j+i*sz_x]=0;
		}
		i=sz_y-1-k;
		for(j=0;j<sz_x;j++){
			inout[j+i*sz_x]=0;
		}
		j=k;
		for(i=0;i<sz_y;i++){
			inout[j+i*sz_x]=0;
		}
		j=sz_x-1-k;
		for(i=0;i<sz_y;i++){
			//printf("%d,%d\n",j,i);
			inout[j+i*sz_x]=0;
		}
	}
	
}
int u_rdfile(unsigned char *buf,const  char *fn, int SZ)
{
	FILE	*fp;
	int ret=0;
	if(NULL== (fp = fopen(fn, "rb")))
	{
		printf(" Read file error!\n\7");
		exit(true);
	}
	ret=fread(buf, sizeof(unsigned char), SZ, fp);
	fclose(fp);

	return (int)true;
}
void getVerticalLine(unsigned char * in, unsigned char *out,int lineNum, int sz_x, int sz_y){
	for(int i=0;i<sz_y;i++){
		out[i]=in[lineNum+i*sz_x];
	}
}
void getHorizonLine(unsigned char * in, unsigned char *out,int lineNum, int sz_x, int sz_y){
	for(int j=0;j<sz_x;j++){
		out[j]=in[j+lineNum*sz_x];
	}
}

int u_wtfile(unsigned char *buf,  const char *fn, int SZ)
{
	#ifndef NATIVE_DEBUG
	FILE	*fp;

	if(NULL == (fp = fopen(fn,"wb")))
	{
		printf(" Write file error!%s\n\7",fn);
		exit(true);
	}

	fwrite(buf, sizeof(unsigned char), SZ, fp);

	fclose(fp);
	#endif
	return true;

}
int getSum(unsigned char *in,  int size){
	int getSum=0;
	for(int i=0;i<size;i++){
		getSum+=in[i];
	}
	return getSum;
}
void showLine(unsigned char *in,  int size){
	printf("----show the line\n");
	for(int i=0;i<size;i++){
		printf("%d\n",in[i]);
	}
	printf("----end\n");
}
	
float getAverage(unsigned char *in,  int size){
	int sum=0;
	sum=getSum(in,size);
	return float(sum)/(float)size;
}
void InitialArray(unsigned char *in, int size){
	for(int i=0;i<size;i++){
		in[i]=0;
	}
}
int getImageCheck(unsigned char *in,int input_x,int input_y, int sz_x, int sz_y, int ExceptionValue){
	int temp;
		if(input_y<0 || input_y>= sz_y){
				temp=ExceptionValue;
			printf("Error %d %d\n",input_x,input_y);
			}else if(input_x<0 || input_x>=sz_x){
				temp=ExceptionValue;
			printf("Error %d %d\n",input_x,input_y);
			}else{
				temp=in[input_x+input_y*sz_x];
			}
	return temp;
	
}
void filterNegative(unsigned char *in, unsigned char *out, int sz_x, int sz_y){
	for(int i=0;i<sz_x*sz_y;i++){
		out[i]=255-in[i];
	}
}
void binarizeImage( unsigned char *in,unsigned char *out,int size_x,int size_y, int threshold){
	for(int i=0;i<size_x*size_y;i++){
		if(in[i]>threshold){
			out[i]=255;
		}else{
			out[i]=0;
		}
	}
}

int calcEdge(int x,int y,int sz_x,int sz_y,unsigned char *in,int flag){
	int temp=0;
	int gravitiy_count=0;
	int element_h=0;
	int element_v=0;
	float square_element=0.0;
	int element_edge=0;
	for(int i=y-1;i<=y+1;i++){
		for(int j=x-1;j<=x+1;j++){
			if(i<0 || i>= sz_y){
				temp=0;
			}else if(j<0 || j>=sz_x){
				temp=0;
			}else{
				temp=in[j+i*sz_x];
			}
			if(flag==SOBEL){
				element_v+=sobelFilter_v[gravitiy_count]*temp;
				element_h+=sobelFilter_h[gravitiy_count]*temp;
			}else if(flag==PREWITT){
				
				element_v+=prewittFilter_v[gravitiy_count]*temp;
				element_h+=prewittFilter_h[gravitiy_count]*temp;
			}else if(flag==ORIGINAL){
				element_v+=originalFilter_v[gravitiy_count]*temp;
				element_h+=originalFilter_h[gravitiy_count]*temp;
			}else{
				printf("No filter \n");
				exit(0);
			}
			
				
			gravitiy_count++;
		}
	}
	square_element=element_v*element_v+element_h*element_h;
	element_edge=(int)sqrt(square_element);
	return element_edge;
	
}
int calcGaussian(int x,int y,int sz_x,int sz_y,unsigned char *in,int flag){
	int temp=0;
	int gravitiy_count=0;
	int element=0;
	//float square_element=0.0;
	int element_edge=0;
	for(int i=y-1;i<=y+1;i++){
		for(int j=x-1;j<=x+1;j++){
			if(i<0 || i>= sz_y){
				temp=0;
			}else if(j<0 || j>=sz_x){
				temp=0;
			}else{
				temp=in[j+i*sz_x];
			}
			
			
				element+=gaussianFilter[gravitiy_count]*temp;
				
			gravitiy_count++;
		}
	}

	element_edge=element/16;
	return element_edge;
	
}
void changePsrLne(unsigned char *in, int size,int width){
	if(width==0){
		printf("Error:no meaning\n");
		exit(0);
	}
	int avg=0;
	int psr=0;
	for(int i=0;i<size;i++){
		avg=0;
		for(int k=i-width;k<i+width;k++){
			avg+=getImageCheck(in,k,0,size,1,255);
		}
		avg/=(2*width+1);
		if(avg==0){
			psr=0;
		}else{
			psr=in[i]/avg;
		}
		printf("%d\n",psr);
	}
}

int getHaiLength(unsigned char *in,int sz_x, int sz_y,int start,int end){
	int distanceMAX=0;
	int set_pos=0;
	int distanceTemp=0;
	for(int i=start;i<end;i++){
		if(in[i]>0){
			distanceTemp=i-set_pos;
			set_pos=i;
			//printf("i=%d %d\n",i,distanceTemp);
			if(distanceMAX<distanceTemp){
				distanceMAX=distanceTemp;
				
			}
		}
	}
	
	return distanceMAX;
}
void getHorizonLine(unsigned char *in, unsigned char *out, int sz_x, int sz_y,int start_y,int width){
	int lineResult=0;
	//int temp=0;
	if(width==0){
		printf("Error:width is 0\n");
		exit(0);
	}
	//printf("-----getHorizon----\n");
	for(int j=0;j<sz_x;j++){
	//	printf("here\n");
		lineResult=0;
		for(int i=start_y;i<start_y+width;i++){
	//		printf("here?\n");
			lineResult+=getImageCheck(in,j,i,sz_x,sz_y,0);
		}
		out[j]=lineResult/width;
	//	printf("%d\n",lineResult/width);
	}
	//printf("---- end -------------\n");
}


void getVerticalLine(unsigned char *in, unsigned char *out, int sz_x, int sz_y,int start_x,int width){
	int lineResult=0;
	//int temp=0;
	if(width==0){
		printf("Error:width is 0\n");
		exit(0);
	}
	//printf("----- getVertical----\n");
	for(int i=0;i<sz_y;i++){
		//printf("here?%d\n",i);
		lineResult=0;
		for(int j=start_x;j<start_x+width;j++){
			lineResult+=getImageCheck(in,j,i,sz_x,sz_y,0);
		}
		out[i]=lineResult/width;
	//	printf("%d\n",lineResult/(width));
	}
		
		
	
	//printf("---- end -------------\n");
}

void filterEdge(unsigned char *in, unsigned char *out, int sz_x, int sz_y,int flag){
	for(int i=0;i<sz_y;i++){
		for(int j=0;j<sz_x;j++){
			out[j+i*sz_x]=calcEdge(j,i,sz_x,sz_y,in,flag);
		}
	}
	CleanEdge(out,sz_x,sz_y,1);
	
}

void filterGaussian(unsigned char *in, unsigned char *out, int sz_x, int sz_y,int flag){
	for(int i=0;i<sz_y;i++){
		for(int j=0;j<sz_x;j++){
			out[j+i*sz_x]=calcGaussian(j,i,sz_x,sz_y,in,flag);
		}
	}
	
}

#ifdef NATIVE_DEBUG
void filterEdgeJint(unsigned char *in, jint *out, int sz_x, int sz_y,int flag){
	if(flag!=GAUSSIAN){
		for(int i=0;i<sz_y;i++){
			for(int j=0;j<sz_x;j++){
				out[j+i*sz_x] = (int)calcEdge(j,i,sz_x,sz_y,in,flag);
			}
		}
	}
}
#endif


int getDecisionForHaiLength(unsigned char *in, unsigned char *out, int sz_x, int sz_y,int start,int end,int flag){
	float min=1000;
	float temp=1000;
	int min_pos=0;
	unsigned char *tempLine;
	if(flag==sz_y){
		tempLine=new unsigned char[sz_y];
	}else{
		tempLine=new unsigned char[sz_x];
	}
	for(int i=start;i<end;i++){
		if(flag==sz_y){
			getVerticalLine(in,tempLine,sz_x,sz_y,i,1);
			temp=getAverage(tempLine,sz_y);
		}else{
			getHorizonLine(in,tempLine,sz_x,sz_y,i,1);
			temp=getAverage(tempLine,sz_x);
		}
		if(min>temp){
			min=temp;
			min_pos=i;
			//printf("%d= %f \n",temp ,i);
			if(flag==sz_y){
				getVerticalLine(in,out,sz_x,sz_y,i,1);
			}else{
				getHorizonLine(in,out,sz_x,sz_y,i,1);
			}
				
		}

	}
	delete [] tempLine;
	return min_pos;
}
int getVerticalFeatureDetector(unsigned char *in,int pos_x,int pos_y,int sz_x, int sz_y,int width, int binaryTh){
	int ImgElement;
	int count=0;
	for(int j=pos_x-width;j<=pos_x+width;j++){
		if(j>=0 && j<sz_x){
			ImgElement=in[j+pos_y*sz_x];
		}else{
			ImgElement=0;
		}
		//printf("%d ",ImgElement);
		if(ImgElement > binaryTh){
			count++;
		}
	}
	return count;
}
int getHorizonFeatureDetector(unsigned char *in,int pos_x,int pos_y,int sz_x, int sz_y,int width, int binaryTh){
	int ImgElement;
	int count=0;
	for(int i=pos_y-width;i<=pos_y+width;i++){
		if(i>=0 && i<sz_y){
			ImgElement=in[pos_x+i*sz_x];
		}else{
			ImgElement=0;
		}
		if(ImgElement > binaryTh){
			count++;
		}
	}
	return count;
}
	
int getLineFeatureImg(unsigned char *in, unsigned char *out,int sz_x, int sz_y,int width, int binaryTh,int flag){
	//int count=0;
	for(int i=0;i<sz_y;i++){
		for(int j=0;j<sz_x;j++){
			if(flag==HORIZON){
				out[j+i*sz_x]=getVerticalFeatureDetector(in,j,i,sz_x,sz_y,width,binaryTh);
			}else{
				out[j+i*sz_x]=getHorizonFeatureDetector(in,j,i,sz_x,sz_y,width,binaryTh);
			}
		}
	}
	
	return 0;
}


int getElement(unsigned char *in,int pos_x,int pos_y,int sz_x, int sz_y){
	if(pos_x >= 0 && pos_x < sz_x && pos_y >= 0 && pos_y <sz_y){
		return in[pos_x+pos_y*sz_x];
	}else{
		return 0;
	}
}

int LineDetecotor(unsigned char *in,unsigned char *out,int sz_x, int sz_y,int width,int binaryTh, int acceptableRange){
	unsigned char *verticalFeatureImg;
	unsigned char *horizonFeatureImg;
	verticalFeatureImg = new unsigned char [sz_x*sz_y];
	horizonFeatureImg =  new unsigned char [sz_x*sz_y];
	
		
	int currentFeature=0;
	int preFeature=255;
	int nextFeature=255;
	int preFeature2=255;
	int nextFeature2=255;
	
	getLineFeatureImg(in,horizonFeatureImg,sz_x,sz_y,width,binaryTh,HORIZON);

	

	InitialArray(out,sz_x*sz_y);
	
	
	for(int i=0;i<sz_y;i++){
		for(int j=0;j<sz_x;j++){
			currentFeature=getElement(horizonFeatureImg,j,i,sz_x,sz_y);
			preFeature=getElement(horizonFeatureImg,j,i-2,sz_x,sz_y);
			nextFeature=getElement(horizonFeatureImg,j,i+2,sz_x,sz_y);
			preFeature2=getElement(horizonFeatureImg,j,i-1,sz_x,sz_y);
			nextFeature2=getElement(horizonFeatureImg,j,i+1,sz_x,sz_y);
			if((currentFeature > width*2-acceptableRange) && ( preFeature < width || nextFeature < width || preFeature2 < width || nextFeature2 < width)){
				out[j+i*sz_x]=255;
			
			}
			
		}
	}
	
	
	//width*=1.3;
	getLineFeatureImg(in,verticalFeatureImg,sz_x,sz_y,width,binaryTh,VERTICAL);
	for(int i=0;i<sz_y;i++){
		for(int j=0;j<sz_x;j++){
			currentFeature=getElement(verticalFeatureImg,j,i,sz_x,sz_y);
			preFeature=getElement(verticalFeatureImg,j-2,i,sz_x,sz_y);
			nextFeature=getElement(verticalFeatureImg,j+2,i,sz_x,sz_y);
			preFeature2=getElement(verticalFeatureImg,j-1,i,sz_x,sz_y);
			nextFeature2=getElement(verticalFeatureImg,j+1,i,sz_x,sz_y);
			if((currentFeature > width*2-acceptableRange) && ( preFeature < width || nextFeature < width || preFeature2 < width || nextFeature2 < width)){
			
				out[j+i*sz_x]=255;
			}
		}
		
	}

	
	
	delete [] verticalFeatureImg;
	delete [] horizonFeatureImg;
	return 0;
}


HiStatus getPosition(unsigned char *in, int sz_x, int sz_y,int pos_x,int pos_y,int hai_x,int hai_y, int delta_x,int delta_y){
	int max_power=-1;
 	int temp_power=0;
	int width=2;
	class HiStatus st;
	
	//printf("debug %d %d - %d %d\n",pos_x,pos_y,hai_x,hai_y);
	for(int k=hai_x-width;k<=hai_x+width;k+=2){
		for(int l=hai_y-width;l<=hai_y+width;l+=2){
			for(int i=pos_y-delta_y;i<pos_y+delta_y;i++){
				for(int j=pos_x-delta_x;j<pos_x+delta_x;j++){
					if(j>=0 && j+k <sz_x && i>=0 && i+l<sz_y){
						temp_power=getRectanglePower(in ,sz_x,sz_y,j,i, k,l,1);
						if(temp_power>max_power){
							max_power=temp_power;
							st.Pos.x=j;
							st.Pos.y=i;
							st.Size.x=k;
							st.Size.y=l;
							st.feature1=max_power;
						}
					}
					
				}
			}
		}
	}
	printf("(%d %d) (%d %d) max_power=%d\n",st.Pos.x,st.Pos.y,st.Size.x,st.Size.y,max_power);
	return st;
}

int getRectanglePower(unsigned char *in, int sz_x, int sz_y,int pos_x,int pos_y,int hai_x,int hai_y,int flag){
	int power=0;
	//int old_power=0;
	int count=0;
	//+	//E
	//printf("---1--\n");
	
	if(!(pos_x>=0 && pos_y>=0 && pos_x+hai_x<sz_x && pos_y+hai_y<sz_y)){
		//printf("exception invalid erea\n");
		return 0;
	}
	for(int i=pos_y;i<pos_y+hai_y/5;i++){
		//printf("%d %d + %d %d\n",pos_x,i,pos_x+hai_x,i);
		power+=in[pos_x+i*sz_x];
		power+=in[pos_x+hai_x+i*sz_x];
		count+=2;
		
	
	}
//	printf("%d\n",power-old_power);
//	old_power=power;
//	printf("---2--\n");
	//+	//E
	for(int i=pos_y+hai_y/5*4;i<pos_y+hai_y;i++){
		//printf("%d %d + %d %d\n",pos_x,i,pos_x+hai_x,i);
		//printf("i=%d",i);
		power+=in[pos_x+i*sz_x];
		power+=in[pos_x+hai_x+i*sz_x];
		count+=2;
	}
//	printf("%d\n",power-old_power);
//	old_power=power;
//	printf("---3--\n");
	//+
	for(int j=pos_x;j<pos_x+hai_x/5;j++){
		//printf("%d %d + %d %d\n",j,pos_y,j,pos_y+hai_y);
		power+=(in[j+pos_y*sz_x]);
		power+=(in[j+(pos_y+hai_y)*sz_x]);
		count+=2;
	}
//	printf("%d\n",power-old_power);
//	old_power=power;
//	printf("---4--\n");
	//+
	for(int j=pos_x+hai_x/5*4;j<pos_x+hai_x;j++){
		//printf("%d %d + %d %d\n",j,pos_y,j,pos_y+hai_y);
		power+=(in[j+pos_y*sz_x]);
		power+=(in[j+(pos_y+hai_y)*sz_x]);
		count+=2;
	}
//	printf("%d\n",power-old_power);
//	old_power=power;
	return power/count;
}

int ChangeView(unsigned char *fixImg,int sz_x, int sz_y,int pos_x,int pos_y,int hai_x,int hai_y,int flag){
	
	//int power=0;
	//+	//E
	for(int i=pos_y;i<pos_y+hai_y;i++){
			fixImg[pos_x+i*sz_x]=0;
			fixImg[pos_x+hai_x+i*sz_x]=0;
	}
	//+
	for(int j=pos_x+1;j<pos_x+hai_x-1;j++){
		fixImg[j+pos_y*sz_x]=0;
		fixImg[j+(pos_y+hai_y)*sz_x]=0;
	}
	return 0;
}


int scaleingHai(int imgWidth,int imgHeight,unsigned char *in,unsigned char *out,class HiStatus Hi){
	unsigned char *extractedHai;
	extractedHai= new unsigned char[Hi.Size.x*Hi.Size.y];
	int count=0;
	for(int i=Hi.Pos.y;i<Hi.Pos.y+Hi.Size.y;i++){
		for(int j=Hi.Pos.x;j<Hi.Pos.x+Hi.Size.x;j++){
			extractedHai[count++]=in[j+i*imgWidth];
		}
	}
	if(Hi.Size.x || Hi.Size.y){
		scalingSize(extractedHai,out,CONST_HAI_WIDTH,CONST_HAI_HEIGHT,Hi.Size.x,Hi.Size.y);
	}else{
		for(int i=0;i<CONST_HAI_WIDTH*CONST_HAI_HEIGHT;i++){
			out[i]=0;
		}
	}
	delete [] extractedHai;
	return 0;
}

int arrangeHai(int imgWidth,int imgHeight,unsigned char *in,int num,unsigned char *out,class HiStatus *HiArray){
	
	//int height=0;
	//int width=0;
	int count=0;
	char str[1024];
	unsigned char *orgnizedHai;
	orgnizedHai=new unsigned char[CONST_HAI_HEIGHT*CONST_HAI_WIDTH];
	for(int i=0;i<num;i++){
		//printf("%d %d : %d %d\n",HiArray[i].Pos.x,HiArray[i].Pos.y,HiArray[i].Size.x,HiArray[i].Size.y);
		scaleingHai(imgWidth,imgHeight,in,orgnizedHai, HiArray[i]);
		CleanEdge(orgnizedHai,CONST_HAI_WIDTH,CONST_HAI_HEIGHT,5);
		for(int j=0;j<CONST_HAI_WIDTH*CONST_HAI_HEIGHT;j++){
			out[count++]=orgnizedHai[j];
		}

		#ifndef NATIVE_DEBUG
		sprintf(str,"hai/hai_%d.raw",i);
		u_wtfile(orgnizedHai, str, CONST_HAI_WIDTH*CONST_HAI_HEIGHT);
		#endif
	}
	//printf("arrangeHaiCount=%d\n",count);
	
	delete [] orgnizedHai;
	return 0;
}
void differentialEdgeX(unsigned char *in,unsigned char *out,int sz_x, int sz_y,float threshold,int width,int over ){
	float point_pre=0;
	float point_aft=0;
	for(int i=0;i<sz_y;i++){
		for(int j=sz_x-1;j>sz_x/2;j--){
			point_pre=0.1;//0Z
			point_aft=0.1;
			for(int k=i-over;k<i+over+1;k++){
				point_pre+=(float)getElement(in,j,k,sz_x,sz_y);
				point_aft+=(float)getElement(in,j-width,k,sz_x,sz_y);

			}
			/*
			for(int k=j-over;k<j+over+1;k++){
				point_pre+=(float)getElement(in,j,i,sz_x,sz_y);
				point_aft+=(float)getElement(in,j-width,i,sz_x,sz_y);

			}*/
			//printf("%f %f\n",point_aft,point_pre);
			if(point_aft/point_pre >threshold){
				out[j+i*sz_x]=255;
			}else{
				out[j+i*sz_x]=0;
			}
		}
		
	}
	

	for(int i=0;i<sz_y;i++){
		for(int j=0;j<sz_x/2;j++){
			point_pre=0.1;//0Z
			point_aft=0.1;
			
			for(int k=i-over;k<i+over+1;k++){
				point_pre+=(float)getElement(in,j,k,sz_x,sz_y);
				point_aft+=(float)getElement(in,j+width,k,sz_x,sz_y);
			}
			/*
			point_pre+=(float)getElement(in,j,i,sz_x,sz_y);
			point_aft+=(float)getElement(in,j+width,i,sz_x,sz_y);
			*/
			if(point_aft/point_pre >threshold){
				out[j+i*sz_x]=255;
			}else{
				out[j+i*sz_x]=0;
			}
		}
		
	}


}


	
void filterHighPass(unsigned char *in,unsigned char *out,int sz_x, int sz_y,int threshold){
	if(threshold==0 || threshold ==255){
		printf("threshold error \n");
		return;
	}
	for(int j=0;j<sz_x*sz_y;j++){
		if(in[j] < threshold){
			out[j] =0;
		}else{
			out[j]=(in[j]-threshold)*255.0/(float)(255.0-threshold);
		}
	}
}

void filterBandPass(unsigned char *in,unsigned char *out,int sz_x, int sz_y,int lowThre,int highThre){

	for(int j=0;j<sz_x*sz_y;j++){
		if(in[j] < lowThre){
			out[j] =0;
		}else if(in[j] > highThre){
			out[j]=255;
		}else{
			out[j]=(in[j]-lowThre)*255.0/(float)(highThre-lowThre);
		}
	}
}
		
void differentialEdgeY(unsigned char *in,unsigned char *out,int sz_x, int sz_y,float threshold,int width,int over){
	//printf("**here\n");
	float point_pre=0;
	float point_aft=0;
	
	for(int j=0;j<sz_x;j++){
		for(int i=sz_y-1;i>=sz_y/2;i--){
			point_pre=0.1;//0Z
			point_aft=0.1;
			for(int k=j-over;k<j+over+1;k++){
				point_pre+=(float)getElement(in,k,i,sz_x,sz_y);
				point_aft+=(float)getElement(in,k,i-width,sz_x,sz_y);
			}
			if(point_aft/point_pre >threshold){
				out[j+i*sz_x]=255;
			}else{
				out[j+i*sz_x]=0;
			}
			
			//printf("%d %d\n",j,i);
		}
		
	}

	for(int j=0;j<sz_x;j++){
		for(int i=0;i<sz_y/2;i++){
			point_pre=0.1;//0Z
			point_aft=0.1;
			for(int k=j-over;k<j+over+1;k++){
				point_pre+=(float)getElement(in,k,i,sz_x,sz_y);
				point_aft+=(float)getElement(in,k,i+width,sz_x,sz_y);
			}
			if(point_aft/point_pre > threshold){
				out[j+i*sz_x]=255;
			}else{
				out[j+i*sz_x]=0;
			}
		}
		
	}
	
}
void setForkFlag(int &ret , int threshold){
	if(ret>threshold){
		ret=1;
	}else{
		ret=0;
	}
}
	

void preImageProcess(int imgWidth,int imgHeight,unsigned char *inImg, unsigned char *outImg){
	unsigned char *edgeImg;
	unsigned char *binaryImg;
	unsigned char *gausuImg;
	unsigned char *highImg;
	unsigned char *edgeVerticalImg;
	unsigned char *edgeHorizonImg;
	unsigned char *tempImg;
	unsigned char *negativeImg;
	unsigned char *edgeImg2;
	
	
	printf("Extracting...  %d %d\n",imgWidth,imgHeight);
	
	edgeImg = new unsigned char [imgWidth * imgHeight];
	binaryImg =new unsigned char [imgWidth * imgHeight];
	gausuImg = new unsigned char[imgWidth *imgHeight];
	highImg = new unsigned char[imgWidth *imgHeight];
	edgeVerticalImg= new unsigned char[imgWidth *imgHeight];
	edgeHorizonImg= new unsigned char[imgWidth *imgHeight];
	tempImg	 =new unsigned char[imgWidth *imgHeight];
	negativeImg = new unsigned char [imgWidth *imgHeight];
	edgeImg2=new unsigned char [imgWidth * imgHeight];
	//IWi
	u_wtfile(inImg,"inImg.raw",imgWidth*imgHeight);
	
	//KEVA
	filterGaussian(inImg,gausuImg,imgWidth,imgHeight,PREWITT);
	u_wtfile(gausuImg,"gausu.raw",imgWidth*imgHeight);
	
	//nCpXtB^
	filterHighPass(gausuImg,highImg,imgWidth,imgHeight,96);
	u_wtfile(highImg,"high.raw",imgWidth*imgHeight);
	
	//filterBandPass(gausuImg,highImg,imgWidth,imgHeight,96,200);
	//u_wtfile(highImg,"high2.raw",imgWidth*imgHeight);
	//GbW
	differentialEdgeX(highImg,edgeHorizonImg,imgWidth,imgHeight,1.05,3,0);
	u_wtfile(edgeHorizonImg,"orgEdgeX.raw",imgWidth*imgHeight);
	
	//GbW
	differentialEdgeY(highImg,edgeVerticalImg,imgWidth,imgHeight,1.05,3,0);
	u_wtfile(edgeVerticalImg,"orgEdgeY.raw",imgWidth*imgHeight);
	
	//]
	filterNegative(highImg,negativeImg,imgWidth,imgHeight);
	u_wtfile(negativeImg,"nagative.raw",imgWidth*imgHeight);
	
	//filter
	filterEdge(negativeImg,edgeImg2,imgWidth,imgHeight,PREWITT);
	u_wtfile(edgeImg2,"edge.raw",imgWidth*imgHeight);
	
	
	
	
	//
	for(int i=0;i<imgWidth*imgHeight;i++){
		if(edgeHorizonImg[i] || edgeVerticalImg[i]){
			edgeImg[i]=255;
		}else{
			edgeImg[i]=0;
		}
	}
	u_wtfile(edgeImg,"orgEdgeXY.raw",imgWidth*imgHeight);
	
	//CleanEdge(edgeImg,imgWidth,imgHeight,1);
	//u_wtfile(edgeImg,"edgeClean.raw",imgWidth*imgHeight);
	//RotateImg(edgeImg2,edgeImg2,imgWidth,imgHeight,1.0);
	//u_wtfile(edgeImg2,"rot.raw",imgWidth*imgHeight);
	
	//]@bΉ
	//RotateImg(edgeImg,edgeImg,imgWidth,imgHeight,-1.0);
	
	
	//2l
	binarizeImage(edgeImg,outImg,imgWidth,imgHeight,32);
	u_wtfile(outImg,"binary.raw",imgWidth*imgHeight);
	//binarizeImage(edgeImg2,outImg,imgWidth,imgHeight,32);
	//u_wtfile(outImg,"binary2.raw",imgWidth*imgHeight);

	//LineDetecotor(edgeImg,binaryImg,imgWidth,imgHeight,LINEDETECTOR_WIDTH,LINEDETECTOR_DEPTH,LINEDETECTOR_ACCEPT);
	//RotateImg(orgImg,outImg,imgWidth,imgHeight,1.0);
	
	
	delete [] edgeImg;
	delete [] binaryImg;
	delete [] gausuImg;
	delete [] highImg;
	delete [] edgeVerticalImg;
	delete [] edgeHorizonImg;	
	delete [] tempImg;
	delete [] negativeImg;
	delete [] edgeImg2;
}
HiStatus getFirstHaiSize(unsigned char *in, int sz_x, int sz_y,int pos_x,int pos_y,int hai_x,int hai_y, int delta_x,int delta_y){
	int max_power=0;
 	int temp_power=0;
	int width=20;
 	class HiStatus st;
	//printf("HERE");
	//printf("debug %d %d - %d %d\n",pos_x,pos_y,hai_x,hai_y);
	for(int k=hai_x-width;k<=hai_x+width;k+=2){
		for(int l=hai_y-width;l<=hai_y+width;l+=2){
			for(int i=pos_y-delta_y;i<pos_y+delta_y;i++){
				for(int j=pos_x-delta_x;j<pos_x+delta_x;j++){
					temp_power=getRectanglePower(in ,sz_x,sz_y,j,i, k,l,1);
					//temp_power/=(hai_x)*2+(hai_y)*2-2;
					//temp_power*=4;
					//temp_power/=(k)*2+(l)*2-2;
					//printf("(%d %d) (%d %d) %d\n",j,i,k,l,temp_power);
					if(temp_power>max_power){
						max_power=temp_power;
						st.Pos.x=j;
						st.Pos.y=i;
						st.Size.x=k;
						st.Size.y=l;
						st.feature1=max_power;
					}
					
				}
			}
		}
	}
	printf("(%d %d) (%d %d) max_power=%d\n",st.Pos.x,st.Pos.y,st.Size.x,st.Size.y,max_power);
	return st;
}

HiStatus detectFirstHai (unsigned char *in, int sz_x, int sz_y,int pos_x,int pos_y,int hai_x,int hai_y, int delta_x,int delta_y){
	HiStatus HiSt;
	HiSt=getFirstHaiSize(in ,sz_x,sz_y,pos_x,pos_y,hai_x,hai_y, delta_x,delta_y);
	return HiSt;
}

HiStatus findFirstHai(unsigned char *in, int sz_x, int sz_y){
	HiStatus st;
	int foundFlag=0;
	for(int j=0;j<sz_x/3;j++){
	//	printf("%d\n",in[j+sz_y/2*sz_x]);
		if(in[j+sz_y/2*sz_x]>128){
			st.Pos.x=j;
			foundFlag=1;
			break;
		}
	}
	if(foundFlag==0){
		printf("Not found find FirstHai at left\n");
		return st;
	}
	foundFlag=0;
	for(int i=0;i<sz_y/2;i++){
		if(in[st.Pos.x+40+i*sz_x]>128){
			st.Pos.y=i;
			foundFlag=1;
			break;
		}
	}
	if(foundFlag==0){
		printf("Not found find FirstHai at top\n");
		return st;
	}
	foundFlag=0;
	for(int i=sz_y;i>sz_y/2;i--){
		if(in[st.Pos.x+40+i*sz_x]>128){
			st.Size.y=i-st.Pos.y;
			foundFlag=1;
			break;
		}
	}
	if(foundFlag==0){
		printf("Not found find FirstHai at bottom\n");
		return st;
	}
	foundFlag=0;
	return st;

}

int judgeExistenceEx(unsigned char *in, int sz_x, int sz_y,int pos_x,int pos_y,int hai_x,int hai_y,int threshold,int &nakiHeight){
	HiStatus st;
	int foundFlag=0;
	int verticalStartPos;
	int vertialEndPos;
	
	if(pos_y-hai_y/2 > 0){
		verticalStartPos=pos_y-hai_y/2;
	}else{
		verticalStartPos=0;
	}

	for(int i=verticalStartPos;i<verticalStartPos+hai_x;i++){
		if(in[pos_x+threshold+i*sz_x]>128){
			st.Pos.y=i;
			foundFlag=1;
			break;
		}
	}
	if(foundFlag==0){
		printf("Not found find existence at top\n");
		return NOEXISTENCE;
	}
	foundFlag=0;
	if(pos_y+hai_y*1.5<sz_y){
		vertialEndPos=pos_y+hai_y*1.5;
	}else{
		vertialEndPos=sz_y;
	}
	for(int i=vertialEndPos;i>vertialEndPos-hai_y;i--){
		if(in[pos_x+threshold+i*sz_x]>128){
			st.Size.y=i-st.Pos.y;
			foundFlag=1;
			break;
		}
	}
	if(foundFlag==0){
		printf("Not found find existence at bottom\n");
		return NOEXISTENCE;
	}
	printf("start,end =%d ,%d\n",verticalStartPos,vertialEndPos);
	printf("EXSITET= %d %d orignailSize=%d\n",st.Pos.y,st.Size.y,hai_y);
	if(st.Size.y > hai_y*0.90 && st.Size.y < hai_y*1.20){	
		return EXISTENCE;
	}else if(st.Size.y>hai_y*0.5){
		nakiHeight=st.Pos.y;
		return NAKIEXISTENCE;
	}else{
		return NOEXISTENCE;
	}

	return NOEXISTENCE;

}
int judgeExistence(unsigned char *in, int sz_x, int sz_y,int pos_x,int pos_y,int hai_x,int hai_y,int &nakiHeight){
	int result;
	int threshold;
	threshold=hai_x*2/4;
	result=judgeExistenceEx(in, sz_x,sz_y,pos_x,pos_y,hai_x,hai_y,threshold,nakiHeight);
	if(result!=NOEXISTENCE){
		return result;
	}
	threshold=hai_x*3/4;
	result=judgeExistenceEx(in, sz_x,sz_y,pos_x,pos_y,hai_x,hai_y,threshold,nakiHeight);
	if(result!=NOEXISTENCE){
		return result;
	}
	threshold=hai_x*1/4;
	result=judgeExistenceEx(in, sz_x,sz_y,pos_x,pos_y,hai_x,hai_y,threshold,nakiHeight);
	if(result!=NOEXISTENCE){
		return result;
	}
	return NOEXISTENCE;

}
//܂ŃtH[N̂悤ȃVXe
int forkSystemX(unsigned char *in,int sz_x, int sz_y, int &start_X,int flag){
	int fork_x[4]={0};
	int fork_max=0;
	int count=0;
	int temp=0;
	int avg=0;
	for(int i=0;i<4;i++){
		fork_x[i]=9999;
	}
	if(flag==FROM_TOP){
		for(int i=0;i<4;i++){
			
			//for(int j=10;j<sz_x/10;j++){
				for(int j=5;j<sz_x/FORK_DIVIDED_NUM_X;j++){

				//printf("%d ",in[j+(i+1)*VERTICAL/5*sz_x]);
				if(in[j+(i+2)*sz_y/7*sz_x]>FORK_EDGE_DETECT_TH){
					fork_x[i]=j;
					break;
				}
			}
			//printf("why\n");
		}
	}else if(flag==FROM_BOTTOM){
		for(int i=0;i<4;i++){
//			for(int j=sz_x-10;j>sz_x*9/10;j--){
				for(int j=sz_x-5;j>sz_x*(FORK_DIVIDED_NUM_X-1)/FORK_DIVIDED_NUM_X;j--){
				//printf("%d ",in[j+(i+1)*VERTICAL/5*sz_x]);
				if(in[j+(i+2)*sz_y/7*sz_x]>FORK_EDGE_DETECT_TH){
					fork_x[i]=j;
					break;
				}
			}
			//printf("why\n");
		}
	}else{
		printf("Error forksystem\n");
		exit(0);
	}
	for(int i=0;i<4;i++){
		
		avg+=fork_x[i];
	}
	printf("%d %d %d %d",fork_x[0],fork_x[1],fork_x[2],fork_x[3]);
	//printf("end\n");
	
	for(int i=0;i<4;i++){
		for(int j=i+1;j<4;j++){
			temp=abs(fork_x[i]-fork_x[j]);
			if(fork_max<temp){
				fork_max=temp;
			}
			
		}
	}
	avg/=4;
	start_X=avg;
//	if(fork_max>15){
		if(fork_max>FORK_THRESHOLD){
		return fork_max;
	}else{
		return 0;
	}
	
}
//܂ŃtH[N̂悤ȃVXe
int forkSystemY(unsigned char *in,int sz_x, int sz_y,int &start_Y,int flag){
	int fork_y[4]={0};
	int fork_y_new[3]={0};
	int fork_max=0;
	int count=0;
	int temp=0;
	int avg=0;
	for(int i=0;i<4;i++){
		fork_y[i]=9999;
	}
	
	if(flag==FROM_LEFT){
		for(int j=0;j<4;j++){
			//for(int i=10;i<sz_y/10;i++){
				for(int i=5;i<sz_y/FORK_DIVIDED_NUM_Y;i++){
		
				//
				if(in[(j+2)*sz_x/7+i*sz_x]>FORK_EDGE_DETECT_TH){
					fork_y[j]=i;
					break;
				}
			}
			//printf("why\n");
		}
	}else if(flag==FROM_RIGHT){
		for(int j=0;j<4;j++){
			//for(int i=sz_y-10;i>sz_y*9/10;i--){
				for(int i=sz_y-5;i>sz_y*(FORK_DIVIDED_NUM_Y-1)/FORK_DIVIDED_NUM_Y;i--){

				//printf("%d %d\n",i,in[(j+1)*HORIZON/5+i*sz_x]);
				if(in[(j+2)*sz_x/7+i*sz_x]>FORK_EDGE_DETECT_TH){
					fork_y[j]=i;
					break;
				}
			}
			//printf("why\n");
		}
	}
		
	for(int i=0;i<4;i++){
//		printf("%d ",fork_y[i]);
		avg+=fork_y[i];
	}
	printf("%d %d %d %d",fork_y[0],fork_y[1],fork_y[2],fork_y[3]);

	//printf("end\n");
	
	for(int i=0;i<4;i++){
		for(int j=i+1;j<4;j++){
			temp=abs(fork_y[i]-fork_y[j]);
			if(fork_max<temp){
				fork_max=temp;
			
			}
			
		}
	}
	avg/=4;
	start_Y=avg;
//	if(fork_max>15){
	if(fork_max>FORK_THRESHOLD){
		return fork_max;
	}else{
		return 0;
	}
	
}
int forkSystemMain(unsigned char *inImg,int sz_x, int sz_y,class HiStatus & haiSet){

	coord startPos,endPos;
	int ret_top,ret_bottom,ret_left,ret_right;
	int Hai_x=0;
	int Hai_y=0;
	
	//tH[NVXe
	printf("top\n");
	ret_top=forkSystemX(inImg,sz_x,sz_y,startPos.x,FROM_TOP);
	printf("bottom\n");
	ret_bottom=forkSystemX(inImg,sz_x,sz_y,endPos.x,FROM_BOTTOM);
	printf("left\n");
	ret_left=forkSystemY(inImg,sz_x,sz_y,startPos.y,FROM_LEFT);
	printf("right\n");
	ret_right=forkSystemY(inImg,sz_x,sz_y,endPos.y,FROM_RIGHT);
	
	printf("Check! %d %d %d %d\n",ret_top,ret_bottom,ret_left,ret_right);

	haiSet.Pos.x=startPos.x;
	haiSet.Pos.y=startPos.y;
	haiSet.Size.x=(endPos.x-startPos.x);
	haiSet.Size.y=(endPos.y-startPos.y);
	
	return 0;
}
int extractSampleHai(int imgWidth,int imgHeight,unsigned char *orgImg,class HiStatus *HiArray){
	
	unsigned char *judgeImg;
	judgeImg = new unsigned char [imgWidth * imgHeight];
	
	int count=0;
	int currentNum=0;
	
	class HiStatus HiSt;
	class HiStatus currentSt;
	class HiStatus nextSt;
	class HiStatus HiInit;
	class HiStatus firstSt;
	class HiStatus haiSet;
	
	
	
	preImageProcess(imgWidth,imgHeight,orgImg,judgeImg);

	forkSystemMain(orgImg,imgWidth,imgHeight,haiSet);

	
	
	currentSt.Pos.x=haiSet.Pos.x;
	currentSt.Pos.y=haiSet.Pos.y;
	currentSt.Size.x=haiSet.Size.x/9;
	currentSt.Size.y=haiSet.Size.y/4;
	currentSt.feature1=255;
	
	//Error Extract Hai (0 0)= (65 40 ) : (58  75)
	printf("*****Welcome to Extracttion Hai\n");
	//Detect FirstHai
	//currentSt=detectFirstHai(judgeImg ,imgWidth,imgHeight,currentSt.Pos.x,currentSt.Pos.y, currentSt.Size.x,currentSt.Size.y, 10,10);
	
	printf("FirstHai (%d %d) (%d %d) =%d\n",currentSt.feature1,currentSt.Pos.x,currentSt.Pos.y,currentSt.Size.x,currentSt.Size.y);
	
	firstSt=currentSt;
	if(currentSt.feature1<100){
			return 0;
	}
	printf("-----Caliculation -----------n");
	
	int flagError=0;
	for(int i=0;i<4;i++){
		for(int j=0;j<9;j++){
			
			if(!(currentSt.Pos.x>=0 && currentSt.Pos.y >=0 && currentSt.Pos.x+currentSt.Size.x<imgWidth &&  currentSt.Pos.y+currentSt.Size.y<imgHeight)){
				printf("Error Extract Hai (%d %d)= (%d %d ) : (%d  %d)\n",j,i,currentSt.Pos.x,currentSt.Pos.y,currentSt.Size.x,currentSt.Size.y);
				flagError=1;
				break;
			}else if(currentSt.Size.y/firstSt.Size.y < 0.85 && currentSt.Size.y/firstSt.Size.y >1.2){
				printf("Error Size Error %f %f\n",currentSt.Size.x/firstSt.Size.x ,currentSt.Size.x/firstSt.Size.x);
				flagError=1;
				break;
			}
			printf("j=%d i=%d ",j,i);
			
			if(j==0){
				HiSt=getPosition(judgeImg ,imgWidth,imgHeight,currentSt.Pos.x,currentSt.Pos.y, currentSt.Size.x,currentSt.Size.y, 10,10);
				nextSt.Pos.x=HiSt.Pos.x;
				nextSt.Pos.y=HiSt.Pos.y;
				nextSt.Size.x=HiSt.Size.x;
				nextSt.Size.y=HiSt.Size.y;
			}else{
				HiSt=getPosition(judgeImg ,imgWidth,imgHeight,currentSt.Pos.x,currentSt.Pos.y, currentSt.Size.x,currentSt.Size.y, 3,3);
				
			}
			
			if(HiSt.feature1>CORRALATION_THRESHOLD){
				count++;
				currentSt=HiSt;
			}else{
				flagError=1;
				printf("The signal is lower Threshold %d \n",HiSt.feature1);
				break;
			}
			
			HiArray[currentNum++]=HiSt;
			//ChangeView(outImg ,imgWidth,imgHeight,HiSt.Pos.x,HiSt.Pos.y, HiSt.Size.x,HiSt.Size.y,1);
			currentSt.Pos.x+=currentSt.Size.x;
			//break;
		}
		if(flagError==1){
			break;
		}
		currentSt.Pos.x =nextSt.Pos.x;
		currentSt.Pos.y =nextSt.Pos.y+nextSt.Size.y;
		currentSt.Size.x=nextSt.Size.x;
		currentSt.Size.y=nextSt.Size.y;
		printf(" Extract Hai = (%d %d ) : (%d  %d)\n",currentSt.Pos.x,currentSt.Pos.y,currentSt.Size.x,currentSt.Size.y);
		
	}

	printf("SUCCESS!valid_count=%d;",count);
	
	for(int i=0;i<count;i++){
		ChangeView(judgeImg ,imgWidth,imgHeight,HiArray[i].Pos.x,HiArray[i].Pos.y, HiArray[i].Size.x,HiArray[i].Size.y,1);
		
	}
	u_wtfile(judgeImg,"judgeImgResult.raw",imgWidth*imgHeight);

	
	printf(" prgram end\n");
	delete [] judgeImg;
	
	
	return count;
}

int extractAgariHai(int imgWidth,int imgHeight,unsigned char *orgImg,class HiStatus *HiArray,int flag,int &haiHeight){
	unsigned char *judgeImg;
	int totalLen=0;
	judgeImg = new unsigned char [imgWidth * imgHeight];
	
	int count=0;
	int currentNum=0;
	

	class HiStatus HiSt;
	class HiStatus currentSt;
	class HiStatus haiSet;
	
	if(flag==MODE_TEHAI){
		printf("------TEHAI----\n");
	}else if(flag==MODE_NAKI){
		printf("------NAKI-----\n");
	}else if(flag==MODE_DORA){
		printf("-------DORA----\n");
	}else{
		printf("mode Error\n");
	}
	
	preImageProcess(imgWidth,imgHeight,orgImg,judgeImg);
	
	currentSt.Pos.x=0;
	currentSt.Pos.y=0;
	currentSt.Size.x=70;
	currentSt.Size.y=100;
	
	//Error Extract Hai (0 0)= (65 40 ) : (58  75)
	printf("*****Welcome to Extracttion Hai...%d %d\n",imgWidth,imgHeight);
	
	forkSystemMain(orgImg,imgWidth,imgHeight,haiSet);
	
	/*
	//Detect FirstHai
	currentSt=findFirstHai(judgeImg ,imgWidth,imgHeight);
	currentSt.Size.x=currentSt.Size.y*0.75;
	//currentSt.Size.x=70;
	printf("find Hai No. (%d %d ) : (%d  %d)\n",currentSt.Pos.x,currentSt.Pos.y,currentSt.Size.x,currentSt.Size.y);
	if(currentSt.Size.x < imgHeight/2){
		return 0;
	}
	*/
	
	currentSt.Pos.x=haiSet.Pos.x;
	currentSt.Pos.y=haiSet.Pos.y;
	currentSt.Size.y=haiSet.Size.y;
	currentSt.Size.x=haiSet.Size.y*0.75;
	
	if(currentSt.Size.y < imgHeight/2 || currentSt.Size.y >= imgHeight || currentSt.Pos.x > imgWidth/5){
		printf("ForkSystemError size over height= %d or invalid position pos.x =%d \n",currentSt.Size.y,currentSt.Pos.x);
		return 0;
	}
		
	currentSt=detectFirstHai(judgeImg ,imgWidth,imgHeight,currentSt.Pos.x,currentSt.Pos.y, currentSt.Size.x,currentSt.Size.y, 10,10);
	
	printf("detect Hai No. (%d %d ) : (%d  %d) =max =%d\n",currentSt.Pos.x,currentSt.Pos.y,currentSt.Size.x,currentSt.Size.y,currentSt.feature1);
	haiHeight=currentSt.Size.y;
	if(currentSt.feature1<100){
		printf("(%d %d) (%d %d) =%d\n",currentSt.feature1,currentSt.Pos.x,currentSt.Pos.y,currentSt.Size.x,currentSt.Size.y);
		return 0;
	}
	int nakiFlag=EXISTENCE;
	int nakiHeight=0;
	
	printf("***************************\n\n");
	while(1){

		if(!(currentSt.Pos.x>=0 && currentSt.Pos.y >=0 && currentSt.Pos.x+currentSt.Size.x<imgWidth &&  currentSt.Pos.y+currentSt.Size.y<imgHeight)){
			printf("Error Extract Hai No.%d (%d %d ) : (%d  %d)\n",currentNum,currentSt.Pos.x,currentSt.Pos.y,currentSt.Size.x,currentSt.Size.y);
			break;
		}
		/*else if(currentSt.Size.y/firstSt.Size.y < 0.85 && currentSt.Size.y/firstSt.Size.y >1.2){
				printf("Error Size Error %f %f\n",currentSt.Size.x/firstSt.Size.x ,currentSt.Size.x/firstSt.Size.x);
				flagError=1;
				break;
		}
		*/
		//printf("countNum ",currentNum);
		nakiFlag=judgeExistence(judgeImg ,imgWidth,imgHeight,currentSt.Pos.x,currentSt.Pos.y, currentSt.Size.x,currentSt.Size.y,nakiHeight);
		if(nakiFlag==EXISTENCE){
			printf("exist normalHai\n");
		}else if(nakiFlag==NOEXISTENCE){
			printf("no eisit Hai\n");
			break;
		}else if(nakiFlag==NAKIEXISTENCE){
			printf("exist NakiHai\n");
		}
		
		if(nakiFlag!=NAKIEXISTENCE || !(flag==MODE_NAKI)){
			//vȊO
			HiSt=getPosition(judgeImg ,imgWidth,imgHeight,currentSt.Pos.x,currentSt.Pos.y, currentSt.Size.x,currentSt.Size.y, 5,5);
		}else{
			//v
			printf("HERE Extract Hai No.%d (%d %d ) : (%d  %d)\n",currentNum,currentSt.Pos.x,currentSt.Pos.y,currentSt.Size.x,currentSt.Size.y);
			HiSt=getPosition(judgeImg ,imgWidth,imgHeight,currentSt.Pos.x,nakiHeight, currentSt.Size.y,currentSt.Size.x, 3,3);
			HiSt.feature2=NAKIFLAG;
		}
		
		if(HiSt.feature1>70){
			count++;
			currentSt=HiSt;
			HiArray[currentNum++]=HiSt;
			currentSt.Pos.x+=currentSt.Size.x;
		}else{
			printf("HAI DETECT END count=%d\n",count);
				break;
		}
		
		if(totalLen>haiSet.Size.x){
			printf("HAI TOTAL LENGTH END %d\n",totalLen);
			break;
		}

		totalLen+=currentSt.Size.x;
		
		
		if(flag==MODE_TEHAI){
			if(count>=MAX_TEHAI){
				break;
			}
		}else if(flag==MODE_NAKI){
			if(count>=MAX_NAKI){
				break;
			}
		}else if(flag==MODE_DORA){
			if(count>=MAX_DORA){
				break;
			}
		}else{
			printf("Error\n");
		}


	}


	printf("SUCCESS!valid_count=%d;",count);

	for(int i=0;i<count;i++){

		if(HiArray[i].feature1>100){
			//printf("here%d\n",i);
			ChangeView(judgeImg ,imgWidth,imgHeight,HiArray[i].Pos.x,HiArray[i].Pos.y, HiArray[i].Size.x,HiArray[i].Size.y,1);
		}
	}
	u_wtfile(judgeImg,"judgeImgResult.raw",imgWidth*imgHeight);
	
	
	printf(" prgram end\n");
	delete [] judgeImg;
	
	return count;
}
