package jp.tonosama.komoki.janscouter;

import jp.tonosama.komoki.janscouterUtil.JanScouterPreference;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.widget.Button;
//import android.widget.TextView;

public class JanScouterActivity extends Activity {

    private final String TAG = "JanScouterActivity";
    private final boolean DebugFlg = false;

    private Button mStartBtn;
    private Button mSampleConfirmBtn;
    private Button mInitialSettngBtn;
    private Button mResultSettngBtn;
    private Button mScoreBtn;
    private Button mSettingBtn;

    public JanScouterActivity(){
        if(DebugFlg) Log.i(TAG, "Instantiated new " + this.getClass());
    }

    private void findAllViewById()
    {
        //((TextView)findViewById(R.id.title)).setText( getResources().getString(R.string.title_main) );
        mStartBtn         = (Button) findViewById(R.id.startBtn);
        mSampleConfirmBtn = (Button) findViewById(R.id.sampleConfirmBtn);
        mInitialSettngBtn = (Button) findViewById(R.id.initialSettingBtn);
        mResultSettngBtn  = (Button) findViewById(R.id.resultSettingBtn);
        mScoreBtn         = (Button) findViewById(R.id.scoreBtn);
        mSettingBtn       = (Button) findViewById(R.id.settingBtn);
    }

    private void setButtonAction()
    {
        mStartBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Log.d(TAG, "start CameraPreview");
                Intent mIntent = new Intent(getApplicationContext(), JanScouterViewActivity.class);
                startActivity(mIntent);
            }
        });
        mSampleConfirmBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Intent mIntent = new Intent(getApplicationContext(), SampleConfirmActivity.class);
                startActivity(mIntent);
            }
        });
        mInitialSettngBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Intent mIntent = new Intent(getApplicationContext(),JanScouterInitialSettingActivity.class);
                startActivity(mIntent);
            }
        });
        mResultSettngBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Intent mIntent = new Intent(getApplicationContext(),JanScouterResultSettingActivity.class);
                startActivity(mIntent);
            }
        });
        mScoreBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Intent mIntent = new Intent(getApplicationContext(),JanScouterScoreTableActivity.class);
                startActivity(mIntent);
            }
        });
        mSettingBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Intent mIntent = new Intent(getApplicationContext(),JanScouterPreference.class);
                startActivity(mIntent);
            }
        });
    }

    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        //getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.main);

        findAllViewById();
        setButtonAction();
    }
}
