package jp.tonosama.komoki.janscouter;

import java.util.ArrayList;
import java.util.Calendar;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;

public class JanScouterInitialSettingActivity extends Activity {

    private final String TAG = "JanScouterInitialSettingActivity";
    private final boolean DebugFlg = false;

    final int BTN_VALUE_5000 = 5000;
    final int BTN_VALUE_100  = 100;
    final int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
    final int MP = LinearLayout.LayoutParams.MATCH_PARENT;

    private Button       mDateButton;
    private Button       mAddButton;
    private Button       mEditButton;
	private EditText     mTitleText;
    private int[]        date = {2000,1,1};

    private CheckBox mYakiEnable;
    private CheckBox mTobiEnable;
    private CheckBox mOrigEnable;
    private CheckBox m1YenEnable;

    private EditText mYakiEdText;
    private EditText mTobiEdText;
    private EditText mOrigEdText;
    private EditText m1YenEdText;

    private ImageButton mYakiUpBtn;
    private ImageButton mYakiDwBtn;
    private ImageButton mTobiUpBtn;
    private ImageButton mTobiDwBtn;
    private ImageButton mOrigUpBtn;
    private ImageButton mOrigDwBtn;
    private ImageButton m1YenUpBtn;
    private ImageButton m1YenDwBtn;

    private LinearLayout mPlayerArea;
    private ArrayAdapter<String> mPlayerNames;


    public JanScouterInitialSettingActivity(){
        if(DebugFlg) Log.i(TAG, "Instantiated new " + this.getClass());
    }
    @Override
    public void onCreate(Bundle icicle)
    {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        //getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.initial_setting);

        findAllViewById();
        setButtonAction();
    }
    @Override
    protected void onResume() {
        super.onResume();
        setPlayerArea();
    }

    private void setPlayerArea()
    {
        // =================================================================
        // vC[Zbg -> S
        mPlayerArea.removeAllViews();
        ArrayList<String> mPlayerNameArray = JanScouterScoreManager.getPlayerNames();
        mPlayerNames = new ArrayAdapter<String>(this, R.layout.spinner);
        mPlayerNames.setDropDownViewResource(R.layout.spinner_dropdown);
        for( int i=0;i<mPlayerNameArray.size();i++ ){
        	mPlayerNames.add(mPlayerNameArray.get(i));
        }
        for( int i=0;i<4;i++ ){
        	addPlayerArea(i);
        }
        // vC[Zbg -> E
        // =================================================================
    }

    private void addPlayerArea(int pos)
    {
    	LinearLayout mPlayerRow = new LinearLayout(this);

    	TextView playerText = new TextView(this);
    	playerText.setText( getResources().getString(R.string.setting_player) + String.valueOf(pos+1) );
    	playerText.setTextColor(Color.BLACK);
        LinearLayout.LayoutParams lp1 = new LinearLayout.LayoutParams(0,WC);
        lp1.weight  = 3;
        playerText.setLayoutParams(lp1);
        playerText.setGravity(Gravity.CENTER_VERTICAL);
        playerText.setTextSize(16);

        Spinner playerSpinner = new Spinner(this);
        LinearLayout.LayoutParams lp2 = new LinearLayout.LayoutParams(0,WC);
        lp2.weight  = 7;
        playerSpinner.setLayoutParams(lp2);
        playerSpinner.setAdapter(mPlayerNames);
        playerSpinner.setSelection(pos);

        mPlayerRow.addView(playerText);
        mPlayerRow.addView(playerSpinner);

        mPlayerArea.addView(mPlayerRow);
    }

    private void findAllViewById()
    {
        ((TextView)findViewById(R.id.title)).setText( getResources().getString(R.string.title_setting) );

        mPlayerArea = (LinearLayout)findViewById(R.id.InitialSettingPlayerArea);
        mDateButton = (Button)findViewById(R.id.setting_date_button);
        mAddButton  = (Button)findViewById(R.id.setting_player_add_button);
        mEditButton = (Button)findViewById(R.id.setting_player_edit_button);
        mTitleText  = (EditText)findViewById(R.id.setting_title_text);

        mYakiEnable = (CheckBox)findViewById(R.id.setting_yakitori_check);
        mTobiEnable = (CheckBox)findViewById(R.id.setting_tobi_check);
        mOrigEnable = (CheckBox)findViewById(R.id.setting_orig_check);
        m1YenEnable = (CheckBox)findViewById(R.id.setting_yen_check);

		if(mYakiEnable.isChecked()) mYakiEnable.setTextColor(Color.BLACK);
		else                        mYakiEnable.setTextColor(Color.GRAY);
		if(mTobiEnable.isChecked()) mTobiEnable.setTextColor(Color.BLACK);
		else                        mTobiEnable.setTextColor(Color.GRAY);
		if(mOrigEnable.isChecked()) mOrigEnable.setTextColor(Color.BLACK);
		else                        mOrigEnable.setTextColor(Color.GRAY);
		if(m1YenEnable.isChecked()) m1YenEnable.setTextColor(Color.BLACK);
		else                        m1YenEnable.setTextColor(Color.GRAY);

        mYakiEdText = (EditText)findViewById(R.id.setting_yakitori_etext);
        mTobiEdText = (EditText)findViewById(R.id.setting_tobi_etext);
        mOrigEdText = (EditText)findViewById(R.id.setting_orig_etext);
        m1YenEdText = (EditText)findViewById(R.id.setting_yen_etext);

        mYakiEdText.setEnabled(mYakiEnable.isChecked());
        mTobiEdText.setEnabled(mTobiEnable.isChecked());
        mOrigEdText.setEnabled(mOrigEnable.isChecked());
        m1YenEdText.setEnabled(m1YenEnable.isChecked());

        mYakiUpBtn = (ImageButton)findViewById(R.id.setting_yakitori_up);
        mTobiUpBtn = (ImageButton)findViewById(R.id.setting_tobi_up);
        mOrigUpBtn = (ImageButton)findViewById(R.id.setting_orig_up);
        m1YenUpBtn = (ImageButton)findViewById(R.id.setting_yen_up);

        mYakiDwBtn = (ImageButton)findViewById(R.id.setting_yakitori_down);
        mTobiDwBtn = (ImageButton)findViewById(R.id.setting_tobi_down);
        mOrigDwBtn = (ImageButton)findViewById(R.id.setting_orig_down);
        m1YenDwBtn = (ImageButton)findViewById(R.id.setting_yen_down);

        mYakiUpBtn.setEnabled(mYakiEnable.isChecked());
        mTobiUpBtn.setEnabled(mTobiEnable.isChecked());
        mOrigUpBtn.setEnabled(mOrigEnable.isChecked());
        m1YenUpBtn.setEnabled(m1YenEnable.isChecked());
        mYakiUpBtn.setImageResource(R.drawable.image_button_add_disable);
        mTobiUpBtn.setImageResource(R.drawable.image_button_add_disable);
        mOrigUpBtn.setImageResource(R.drawable.image_button_add_disable);
        m1YenUpBtn.setImageResource(R.drawable.image_button_add_disable);

        mYakiDwBtn.setEnabled(mYakiEnable.isChecked());
        mTobiDwBtn.setEnabled(mTobiEnable.isChecked());
        mOrigDwBtn.setEnabled(mOrigEnable.isChecked());
        m1YenDwBtn.setEnabled(m1YenEnable.isChecked());
        mYakiDwBtn.setImageResource(R.drawable.image_button_minus_disable);
        mTobiDwBtn.setImageResource(R.drawable.image_button_minus_disable);
        mOrigDwBtn.setImageResource(R.drawable.image_button_minus_disable);
        m1YenDwBtn.setImageResource(R.drawable.image_button_minus_disable);

        Calendar calendar = Calendar.getInstance();
        date[0] = calendar.get(Calendar.YEAR);
        date[1] = calendar.get(Calendar.MONTH)+1;
        date[2] = calendar.get(Calendar.DAY_OF_MONTH);
        mDateButton.setText( String.format( "%1$d/%2$d/%3$d", date[0],date[1],date[2] ) );
        //mTitleText.setText( String.format( "%1$d/%2$d/%3$d", date[0],date[1],date[2] ) );
        mTitleText.setText( String.format( "" ) );
    }

    private void setButtonAction()
    {
        mDateButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                new DatePickerDialog(JanScouterInitialSettingActivity.this, new DatePickerDialog.OnDateSetListener() {
                    @Override
                    public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth)
                    {
                        date[0] = year;
                        date[1] = monthOfYear+1;
                        date[2] = dayOfMonth;
                        mDateButton.setText( String.format( "%1$d/%2$d/%3$d", date[0],date[1],date[2] ) );
                    }
                }, date[0], date[1]-1, date[2])
                .show();
            }
        });
        mAddButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v)
            {
                Intent mIntent = new Intent(getApplicationContext(), JanScouterPlayerEditActivity.class);
                mIntent.putExtra(JanScouterPlayerEditActivity.IS_NEW_CREATE_MODE_KEY, true);
                startActivity(mIntent);
            }
        });
        mEditButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                Intent mIntent = new Intent(getApplicationContext(), JanScouterPlayerEditActivity.class);
                startActivity(mIntent);
            }
        });

        mYakiUpBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	int value = Integer.parseInt(mYakiEdText.getText().toString()) + BTN_VALUE_5000;
            	mYakiEdText.setText(String.valueOf(value));
            }
        });
        mYakiDwBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	int value = Integer.parseInt(mYakiEdText.getText().toString()) - BTN_VALUE_5000;
            	if(value<0) value = 0;
            	mYakiEdText.setText(String.valueOf(value));
            }
        });
        mTobiUpBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	int value = Integer.parseInt(mTobiEdText.getText().toString()) + BTN_VALUE_5000;
            	mTobiEdText.setText(String.valueOf(value));
            }
        });
        mTobiDwBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	int value = Integer.parseInt(mTobiEdText.getText().toString()) - BTN_VALUE_5000;
            	if(value<0) value = 0;
            	mTobiEdText.setText(String.valueOf(value));
            }
        });
        mOrigUpBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	int value = Integer.parseInt(mOrigEdText.getText().toString()) + BTN_VALUE_5000;
            	mOrigEdText.setText(String.valueOf(value));
            }
        });
        mOrigDwBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	int value = Integer.parseInt(mOrigEdText.getText().toString()) - BTN_VALUE_5000;
            	if(value<0) value = 0;
            	mOrigEdText.setText(String.valueOf(value));
            }
        });
        m1YenUpBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	int value = Integer.parseInt(m1YenEdText.getText().toString()) + BTN_VALUE_100;
            	m1YenEdText.setText(String.valueOf(value));
            }
        });
        m1YenDwBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	int value = Integer.parseInt(m1YenEdText.getText().toString()) - BTN_VALUE_100;
            	if(value<0) value = 0;
            	m1YenEdText.setText(String.valueOf(value));
            }
        });


        mYakiEnable.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton arg0, boolean isChecked)
			{
				mYakiUpBtn.setEnabled(isChecked);
				mYakiDwBtn.setEnabled(isChecked);
				mYakiEdText.setEnabled(isChecked);
				if(isChecked) mYakiEnable.setTextColor(Color.BLACK);
				else          mYakiEnable.setTextColor(Color.GRAY);
				if(isChecked) mYakiUpBtn.setImageResource(R.drawable.image_button_add);
				else          mYakiUpBtn.setImageResource(R.drawable.image_button_add_disable);
				if(isChecked) mYakiDwBtn.setImageResource(R.drawable.image_button_minus);
				else          mYakiDwBtn.setImageResource(R.drawable.image_button_minus_disable);
			}
        });
        mTobiEnable.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton arg0, boolean isChecked)
			{
				mTobiUpBtn.setEnabled(isChecked);
				mTobiDwBtn.setEnabled(isChecked);
				mTobiEdText.setEnabled(isChecked);
				if(isChecked) mTobiEnable.setTextColor(Color.BLACK);
				else          mTobiEnable.setTextColor(Color.GRAY);
				if(isChecked) mTobiUpBtn.setImageResource(R.drawable.image_button_add);
				else          mTobiUpBtn.setImageResource(R.drawable.image_button_add_disable);
				if(isChecked) mTobiDwBtn.setImageResource(R.drawable.image_button_minus);
				else          mTobiDwBtn.setImageResource(R.drawable.image_button_minus_disable);
			}
        });
        mOrigEnable.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton arg0, boolean isChecked)
			{
				mOrigUpBtn.setEnabled(isChecked);
				mOrigDwBtn.setEnabled(isChecked);
				mOrigEdText.setEnabled(isChecked);
				if(isChecked) mOrigEnable.setTextColor(Color.BLACK);
				else          mOrigEnable.setTextColor(Color.GRAY);
				if(isChecked) mOrigUpBtn.setImageResource(R.drawable.image_button_add);
				else          mOrigUpBtn.setImageResource(R.drawable.image_button_add_disable);
				if(isChecked) mOrigDwBtn.setImageResource(R.drawable.image_button_minus);
				else          mOrigDwBtn.setImageResource(R.drawable.image_button_minus_disable);
			}
        });
        m1YenEnable.setOnCheckedChangeListener(new OnCheckedChangeListener() {
			@Override
			public void onCheckedChanged(CompoundButton arg0, boolean isChecked)
			{
				m1YenUpBtn.setEnabled(isChecked);
				m1YenDwBtn.setEnabled(isChecked);
				m1YenEdText.setEnabled(isChecked);
				if(isChecked) m1YenEnable.setTextColor(Color.BLACK);
				else          m1YenEnable.setTextColor(Color.GRAY);
				if(isChecked) m1YenUpBtn.setImageResource(R.drawable.image_button_add);
				else          m1YenUpBtn.setImageResource(R.drawable.image_button_add_disable);
				if(isChecked) m1YenDwBtn.setImageResource(R.drawable.image_button_minus);
				else          m1YenDwBtn.setImageResource(R.drawable.image_button_minus_disable);
			}
        });
    }
}
