package jp.tonosama.komoki.janscouter;

import java.util.ArrayList;

import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;

public class JanScouterPlayerEditActivity extends Activity {

    private final String TAG = "JanScouterPlayerEditActivity";
    private final boolean DebugFlg = false;

    private Button mSaveBtn;
    private final int NEW_PLAYER_EDITTEXT_ID = 100101;

    private boolean isNewCreateMode = false;
    public static String IS_NEW_CREATE_MODE_KEY = "IS_NEW_CREATE_MODE_KEY";

    final int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
    final int MP = LinearLayout.LayoutParams.MATCH_PARENT;

    private LinearLayout mPlayerEditArea;

    public JanScouterPlayerEditActivity() {
        if (DebugFlg)
            Log.i(TAG, "Instantiated new " + this.getClass());
    }

    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        // getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.player_edit);

        Bundle bundle = getIntent().getExtras();
        if(bundle!=null) isNewCreateMode = bundle.getBoolean(IS_NEW_CREATE_MODE_KEY);

        findAllViewById();
        setButtonAction();
        setPlayerEditArea();
    }

    private void findAllViewById()
    {
        mSaveBtn        = (Button) findViewById(R.id.PlayerEditSaveSettingBtn);
        mPlayerEditArea = (LinearLayout) findViewById(R.id.PlayerEditRoot);
    }

    private void setButtonAction()
    {
        mSaveBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v)
            {
                for( int i=0;i<JanScouterScoreManager.mPlayerNameArray.size();i++ )
                {
                    String name = ((EditText)findViewById(NEW_PLAYER_EDITTEXT_ID + i)).getText().toString();
                    JanScouterScoreManager.mPlayerNameArray.set(i, name);
                }
                if(isNewCreateMode){
                    int pos = JanScouterScoreManager.mPlayerNameArray.size();
                    String new_name = ((EditText)findViewById(NEW_PLAYER_EDITTEXT_ID + pos )).getText().toString();
                    JanScouterScoreManager.mPlayerNameArray.add(new_name);
                }
                JanScouterPlayerEditActivity.this.finish();
            }
        });
    }

    private void setPlayerEditArea() {
        ArrayList<String> mPlayerNameArray = JanScouterScoreManager.getPlayerNames();

        for (int i = 0; i < mPlayerNameArray.size(); i++)
        {
            LinearLayout mPlayerRow = new LinearLayout(this);
            TextView playerText = new TextView(this);
            playerText.setText(getResources().getString(R.string.setting_player) + String.valueOf(i + 1));
            playerText.setTextColor(Color.BLACK);
            LinearLayout.LayoutParams lp1 = new LinearLayout.LayoutParams(0, WC);
            lp1.weight = 3;
            playerText.setLayoutParams(lp1);
            playerText.setGravity(Gravity.CENTER_VERTICAL);
            playerText.setTextSize(16);

            EditText mEditText = new EditText(this);
            mEditText.setId(NEW_PLAYER_EDITTEXT_ID + i);
            LinearLayout.LayoutParams lp2 = new LinearLayout.LayoutParams(0, WC);
            lp2.weight = 7;
            mEditText.setLayoutParams(lp2);
            mEditText.setText(mPlayerNameArray.get(i));
            mEditText.setSingleLine();

            mPlayerRow.addView(playerText);
            mPlayerRow.addView(mEditText);

            mPlayerEditArea.addView(mPlayerRow);
        }

        if(isNewCreateMode)
        {
            int pos = mPlayerNameArray.size();
            LinearLayout mPlayerRow = new LinearLayout(this);
            TextView playerText = new TextView(this);
            playerText.setText(getResources().getString(R.string.setting_player) + String.valueOf(pos+1));
            playerText.setTextColor(Color.BLACK);
            LinearLayout.LayoutParams lp1 = new LinearLayout.LayoutParams(0, WC);
            lp1.weight = 3;
            playerText.setLayoutParams(lp1);
            playerText.setGravity(Gravity.CENTER_VERTICAL);
            playerText.setTextSize(16);
            playerText.setTextColor(Color.RED);

            EditText mEditText = new EditText(this);
            mEditText.setId(NEW_PLAYER_EDITTEXT_ID + pos);
            LinearLayout.LayoutParams lp2 = new LinearLayout.LayoutParams(0, WC);
            lp2.weight = 7;
            mEditText.setLayoutParams(lp2);
            mEditText.setText( getResources().getString(R.string.setting_player) + String.valueOf(pos+1) );
            mEditText.setSingleLine();

            mPlayerRow.addView(playerText);
            mPlayerRow.addView(mEditText);

            mPlayerEditArea.addView(mPlayerRow);
        }
    }
}
