package jp.tonosama.komoki.janscouter;

import jp.tonosama.komoki.wheel.widget.NumericWheelAdapter;
import jp.tonosama.komoki.wheel.widget.WheelView;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.TextView;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.LinearLayout;
import android.widget.ToggleButton;

public class JanScouterResultSettingActivity extends Activity {

    private final String TAG = "JanScouterResultSettingActivity";
    private final boolean DebugFlg = false;

    final int PD = 20;
    final int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
    final int MP = LinearLayout.LayoutParams.MATCH_PARENT;

    private ToggleButton mTonbaBtn;
    private ToggleButton mNanbaBtn;
    private ToggleButton mTonBtn;
    private ToggleButton mNanBtn;
    private ToggleButton mShaBtn;
    private ToggleButton mPeeBtn;

    private int mCurrentHonba = 0;
    private Button mHonbaButton;
    private Button mRonButton;
    private Button mTsumoButton;

    private ToggleButton mReachBtn;
    private ToggleButton mIppatsuBtn;
    private ToggleButton mRinshanBtn;
    private ToggleButton mChankanBtn;

    private boolean isTsumo   = false;
    private boolean isReach   = false;
    private boolean isIppatsu = false;
    private boolean isRinshan = false;
    private boolean isChankan = false;

    private WheelView mWheelView;

    public JanScouterResultSettingActivity() {
        if (DebugFlg)
            Log.i(TAG, "Instantiated new " + this.getClass());
    }

    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        // getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
        setContentView(R.layout.result_setting);

        findAllViewById();
        setAllViewAction();
    }

    private void findAllViewById()
    {
        ((TextView)findViewById(R.id.title)).setText(getResources().getString(R.string.btn_result_scouter));
        mTonbaBtn = (ToggleButton) findViewById(R.id.result_setting_tonba);
        mNanbaBtn = (ToggleButton) findViewById(R.id.result_setting_nanba);
        mTonbaBtn.setChecked(true);
        mNanbaBtn.setChecked(false);

        mTonBtn = (ToggleButton) findViewById(R.id.result_setting_ton);
        mNanBtn = (ToggleButton) findViewById(R.id.result_setting_nan);
        mShaBtn = (ToggleButton) findViewById(R.id.result_setting_sha);
        mPeeBtn = (ToggleButton) findViewById(R.id.result_setting_pee);
        mTonBtn.setChecked(true);
        mNanBtn.setChecked(false);
        mShaBtn.setChecked(false);
        mPeeBtn.setChecked(false);

        mReachBtn   = (ToggleButton) findViewById(R.id.result_reach_btn);
        mIppatsuBtn = (ToggleButton) findViewById(R.id.result_ippatsu_btn);
        mRinshanBtn = (ToggleButton) findViewById(R.id.result_rinshan_btn);
        mChankanBtn = (ToggleButton) findViewById(R.id.result_chankan_btn);

        mHonbaButton = (Button) findViewById(R.id.result_setting_honba_btn);
        mHonbaButton.setText(String.valueOf(mCurrentHonba));
        mRonButton = (Button) findViewById(R.id.result_setting_ron_btn);
        mTsumoButton = (Button) findViewById(R.id.result_setting_tsumo_btn);
    }

    private void setAllViewAction()
    {
        mTonbaBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                mTonbaBtn.setChecked(true);
                mNanbaBtn.setChecked(false);
            }
        });
        mNanbaBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                mTonbaBtn.setChecked(false);
                mNanbaBtn.setChecked(true);
            }
        });

        mReachBtn.setOnCheckedChangeListener(new OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                isReach = isChecked;
            }
        });
        mIppatsuBtn.setOnCheckedChangeListener(new OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                isIppatsu = isChecked;
            }
        });
        mRinshanBtn.setOnCheckedChangeListener(new OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                isRinshan = isChecked;
            }
        });
        mChankanBtn.setOnCheckedChangeListener(new OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                isChankan = isChecked;
            }
        });

        mTonBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                mTonBtn.setChecked(true);
                mNanBtn.setChecked(false);
                mShaBtn.setChecked(false);
                mPeeBtn.setChecked(false);
            }
        });
        mNanBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                mTonBtn.setChecked(false);
                mNanBtn.setChecked(true);
                mShaBtn.setChecked(false);
                mPeeBtn.setChecked(false);
            }
        });
        mShaBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                mTonBtn.setChecked(false);
                mNanBtn.setChecked(false);
                mShaBtn.setChecked(true);
                mPeeBtn.setChecked(false);
            }
        });
        mPeeBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                mTonBtn.setChecked(false);
                mNanBtn.setChecked(false);
                mShaBtn.setChecked(false);
                mPeeBtn.setChecked(true);
            }
        });

        mHonbaButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                LinearLayout mWrapper = new LinearLayout(JanScouterResultSettingActivity.this);
                mWheelView = new WheelView(JanScouterResultSettingActivity.this,null);
                mWheelView.setVisibleItems(5);
                mWheelView.setAdapter(new NumericWheelAdapter(0, 20));
                mWheelView.setCurrentItem(mCurrentHonba);
                mWrapper.setPadding(PD, PD, PD, PD);
                mWrapper.addView(mWheelView,MP,MP);
                new AlertDialog.Builder(JanScouterResultSettingActivity.this)
                .setTitle("I")
                .setView(mWrapper)
                .setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton)
                    {
                        mCurrentHonba = mWheelView.getCurrentItem();
                        mHonbaButton.setText(String.valueOf(mCurrentHonba));
                    }
                })
                .setNegativeButton(android.R.string.cancel, new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton)
                    {
                    }
                })
                .show();
            }
        });

        mRonButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {

                isTsumo   = false;
                isReach   = mReachBtn.isChecked();
                isIppatsu = mIppatsuBtn.isChecked();
                isRinshan = mRinshanBtn.isChecked();
                isChankan = mChankanBtn.isChecked();
                boolean[] condition = { isTsumo,isReach,isIppatsu,isRinshan,isChankan };

                Intent mIntent = new Intent(getApplicationContext(), ResultDetectorActivity.class);
                mIntent.putExtra(ResultDetectorActivity.CONDITION_KEY, condition);
                startActivity(mIntent);
            }
        });
        mTsumoButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {

                isTsumo   = true;
                isReach   = mReachBtn.isChecked();
                isIppatsu = mIppatsuBtn.isChecked();
                isRinshan = mRinshanBtn.isChecked();
                isChankan = mChankanBtn.isChecked();
                boolean[] condition = { isTsumo,isReach,isIppatsu,isRinshan,isChankan };

                Intent mIntent = new Intent(getApplicationContext(), ResultDetectorActivity.class);
                mIntent.putExtra(ResultDetectorActivity.CONDITION_KEY, condition);
                startActivity(mIntent);
            }
        });
    }
}
