package jp.tonosama.komoki.janscouter;

import java.util.ArrayList;
import java.util.Random;

import android.util.Log;

public class JanScouterScoreManager {

    private final String TAG = "JanScouterScoreManager";
    private final boolean DebugFlg = false;

    public static ArrayList<String> mPlayerNameArray;
    public static ArrayList<ArrayList<Integer>> mResultScoreArray;

    public static String[] PRESET_NAMES = {"Ȃ","Fl`","Fla","Flb"};

    public JanScouterScoreManager(){
        if(DebugFlg) Log.i(TAG, "Instantiated new " + this.getClass());

        mPlayerNameArray  = new ArrayList<String>();
        mResultScoreArray = new ArrayList<ArrayList<Integer>>();
    }

    public static ArrayList<ArrayList<Integer>> getScoreArray(){
        return mResultScoreArray;
    }
    public static ArrayList<String> getPlayerNames(){
        if(mPlayerNameArray==null){
            mPlayerNameArray  = new ArrayList<String>();
            for( int i=0;i<PRESET_NAMES.length;i++ ){
                mPlayerNameArray.add(PRESET_NAMES[i]);
            }
        }
        return mPlayerNameArray;
    }

    public void setRandomPlayers()
    {
        Random random  = new Random();
        int player_num = 3 + random.nextInt(8);
        for( int i=0;i<player_num;i++ ){
            if( i < PRESET_NAMES.length ){
                mPlayerNameArray.add(PRESET_NAMES[i]);
            }else{
                mPlayerNameArray.add(String.format("Fl%1$d",i+1));
            }
        }
    }

    public void setRandomScores()
    {
        int player_num = mPlayerNameArray.size();
        Random rand_data_num = new Random();
        int data_num   = 5 + rand_data_num.nextInt(20);
        for( int i=0;i<data_num;i++ )
        {
            ArrayList<Integer> mResult = new ArrayList<Integer>();
            for( int j=0;j<player_num;j++ )
            {
                Random rand_score = new Random();
                mResult.add( rand_score.nextInt(100) - 50 );
            }
            mResultScoreArray.add(mResult);
        }
    }

    public ArrayList<Integer> getTotalResult()
    {
        int player_num = mPlayerNameArray.size();
        int data_num   = mResultScoreArray.size();
        ArrayList<Integer> total_result = new ArrayList<Integer>();

        for( int i=0;i<player_num;i++ )
        {
            int score = 0;
            for( int j=0;j<data_num;j++ )
            {
                score += mResultScoreArray.get(j).get(i);
            }
            total_result.add(score);
        }
        return total_result;
    }

    public void addDataTest()
    {
        int player_num = mPlayerNameArray.size();
        ArrayList<Integer> mResult = new ArrayList<Integer>();
        for( int j=0;j<player_num;j++ )
        {
            Random rand_score = new Random();
            mResult.add( rand_score.nextInt(100) - 50 );
        }
        mResultScoreArray.add(mResult);
    }
}
