package jp.tonosama.komoki.janscouter;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import jp.tonosama.komoki.objectInfo.HiInfo;
import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.Bitmap.Config;
import android.os.Bundle;
import android.os.Environment;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ScrollView;
import android.widget.Toast;

public class SampleConfirmActivity extends Activity {

    private final String TAG = "SampleConfirmActivity";
    private final boolean DebugFlg = false;


    public SampleConfirmActivity(){
        if(DebugFlg) Log.i(TAG, "Instantiated new " + this.getClass());
    }

    private void findAllViewById()
    {
    }

    private void setAllViewAction()
    {
    }

    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        //getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);

        findAllViewById();
        setAllViewAction();

        int length = HiInfo.HI_WIDTH * HiInfo.HI_HEIGHT * HiInfo.TOTAL_HI_NUM ;
        String filename  = HiInfo.SAMPLE_IMAGE_FILE_NAME;
        String directory = Environment.getExternalStorageDirectory().toString() + HiInfo.SAMPLE_IMAGE_FILE_PATH;

        byte[] mAllHiArray = null;
        FileInputStream in = null;
        File file = new File(directory, filename);
        try {
            in = new FileInputStream(file);
            mAllHiArray = new byte[ length ];
            try {
                in.read(mAllHiArray);
            } catch (IOException e) {
                Toast.makeText(getApplicationContext(), "IOException", Toast.LENGTH_SHORT).show();
                e.printStackTrace();
            }
        } catch (FileNotFoundException e) {
            Toast.makeText(getApplicationContext(), "FileNotFoundException", Toast.LENGTH_SHORT).show();
            e.printStackTrace();
        }
        if( mAllHiArray == null ){
            finish();
            return;
        }

        int[][] mHiArray = new int[HiInfo.TOTAL_HI_NUM][HiInfo.HI_WIDTH*HiInfo.HI_HEIGHT];

        for( int i=0;i<HiInfo.TOTAL_HI_NUM;i++ ){
            for( int j=0;j<HiInfo.HI_WIDTH*HiInfo.HI_HEIGHT;j++ )
            {
                int value = mAllHiArray[i*HiInfo.HI_WIDTH*HiInfo.HI_HEIGHT + j] & 0xff;
                mHiArray[i][j] = Color.rgb(value, value, value);
            }
        }

        DisplayMetrics displayMetrics = new DisplayMetrics();
        getWindowManager().getDefaultDisplay().getMetrics(displayMetrics);
        int imageWidth  = (int)(displayMetrics.widthPixels / 10);
        int imageHeight = (int)(imageWidth * 1.5f);

        ScrollView   wrapScrollView     = new ScrollView(this);
        LinearLayout resultLinearLayout = new LinearLayout(this);
        resultLinearLayout.setOrientation(LinearLayout.VERTICAL);

        Bitmap[]    hiBmp = new Bitmap[HiInfo.TOTAL_HI_NUM];
        ImageView[] image = new ImageView[HiInfo.TOTAL_HI_NUM];
        LinearLayout[] eachRowLLayout = new LinearLayout[4];

        for( int i=0;i<4;i++ )
        {
            eachRowLLayout[i] = new LinearLayout(this);
            eachRowLLayout[i].setOrientation(LinearLayout.HORIZONTAL);
        }
        for( int i=0;i<HiInfo.TOTAL_HI_NUM;i++ )
        {
            image[i] = new ImageView(this);
            hiBmp[i] = Bitmap.createBitmap(mHiArray[i], HiInfo.HI_WIDTH, HiInfo.HI_HEIGHT, Config.RGB_565);
            image[i].setImageBitmap(hiBmp[i]);
            image[i].setScaleType(ImageView.ScaleType.CENTER);
            image[i].setPadding(10, 10, 5, 5);
            eachRowLLayout[i/9].addView(image[i], imageWidth, imageHeight);
            if(i%9==8 || i==HiInfo.TOTAL_HI_NUM-1) resultLinearLayout.addView(eachRowLLayout[i/9], ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        }
        Button closeBtn = new Button(this);
        closeBtn.setText(getResources().getString(R.string.scouter_scan_close));
        closeBtn.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                finish();
            }
        });
        resultLinearLayout.addView(closeBtn, ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        wrapScrollView.addView(resultLinearLayout, ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        addContentView(wrapScrollView, new LinearLayout.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT));
    }
}
