package jp.tonosama.komoki.janscouterUtil;

import jp.tonosama.komoki.janscouter.R;
import android.os.Bundle;
import android.preference.CheckBoxPreference;
import android.preference.Preference;
import android.preference.PreferenceActivity;
import android.util.Log;

public class JanScouterPreference extends PreferenceActivity {

    private final String TAG = "JanScouterPreference";
    private final boolean DebugFlg = false;

    @SuppressWarnings("unused")
	private CheckBoxPreference IS_USE_VERTICAL_SCREEN;
    private CheckBoxPreference IS_ONLY_ANALYZE;
    private CheckBoxPreference IS_ONLY_PREVIEW;

    public JanScouterPreference(){
        if(DebugFlg) Log.i(TAG, "Instantiated new " + this.getClass());
    }
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        addPreferencesFromResource(R.xml.pref);

        IS_USE_VERTICAL_SCREEN = (CheckBoxPreference)findPreference("IS_USE_VERTICAL_SCREEN");
        IS_ONLY_ANALYZE        = (CheckBoxPreference)findPreference("IS_ONLY_ANALYZE");
        IS_ONLY_PREVIEW        = (CheckBoxPreference)findPreference("IS_ONLY_PREVIEW");

        checkAnalyzePreference( IS_ONLY_PREVIEW.isChecked() );

        IS_ONLY_PREVIEW.setOnPreferenceChangeListener(new Preference.OnPreferenceChangeListener(){
            @Override
            public boolean onPreferenceChange(Preference preference, Object newValue) {
                checkAnalyzePreference( ((Boolean)newValue).booleanValue() );
                return true;
            }
        });
        IS_ONLY_ANALYZE.setOnPreferenceChangeListener(new Preference.OnPreferenceChangeListener(){
            @Override
            public boolean onPreferenceChange(Preference preference, Object newValue) {
                return true;
            }
        });
    }

    private void checkAnalyzePreference(boolean check){
        if(check){
            IS_ONLY_ANALYZE.setEnabled(false);
        }else{
            IS_ONLY_ANALYZE.setEnabled(true);
        }
    }
}