package jp.tonosama.komoki.objectInfo;

import java.util.ArrayList;

import android.graphics.Point;
import android.util.Log;

public class HiInfo {

    private final String TAG = "HiInfo";
    private final boolean DebugFlg = false;

    private int mHiTotalNum;
    private int mDetectResult = -1;
    private ArrayList<Point> mHiPoint;
    private ArrayList<Point> mHiSize;

    public  byte[] mHiArray;
    public static final int HI_WIDTH  = 64;
    public static final int HI_HEIGHT = 96;
    public static final int TOTAL_HI_NUM = 34;

    public static final String SAMPLE_IMAGE_FILE_NAME = "hai_sample.raw";
    public static final String SAMPLE_IMAGE_FILE_PATH = "/JanScouter/debug";

    public static final int SCAN_HI_NUM = 36;

    public HiInfo() {
        if(DebugFlg) Log.i(TAG, "Instantiated new " + this.getClass());
        mHiPoint = new ArrayList<Point>();
        mHiSize  = new ArrayList<Point>();
        mHiArray = new byte[HI_WIDTH*HI_HEIGHT*TOTAL_HI_NUM];
    }
    public void setGuideInfo(){

    }

    public void setHiInfo(int[] hi_point_x, int[] hi_point_y, int[] hi_width, int[] hi_height, int[] edge_img)
    {
        if( hi_point_x == null || hi_point_y == null || hi_width == null || hi_height == null ){
            Log.d(TAG, "hi data is invalid! can't set HiInfo !!");
            return;
        }
        mHiTotalNum = hi_point_x.length;
        mHiPoint.clear();
        mHiSize.clear();
        for(int i=0;i<mHiTotalNum;i++)
        {
            Log.d(TAG, "i="+i+"; (" + hi_point_x[i] + "," + hi_point_y[i] + ")" + "(" + hi_width[i] + "," + hi_height[i] + ")");
            Point hi_point = new Point(hi_point_x[i],hi_point_y[i]);
            Point hi_size  = new Point(hi_width[i],  hi_height[i]);
            mHiPoint.add(hi_point);
            mHiSize.add(hi_size);
        }
    }

    public void setDetectResult(int result){
        mDetectResult = result;
    }
    public int getDetectResult(){
        return mDetectResult;
    }
    public void setHiArray( byte[] hi_array ){
        mHiArray = hi_array.clone();
    }
    public byte[] getHiArray(){
        return mHiArray;
    }
    public String getDetectResultMsg(){
        String resultMsg = "";
        resultMsg = "Found " + String.valueOf(mDetectResult) + " hai!";
        return resultMsg;
    }

    public int getHiTotalNum(){
        return mHiTotalNum;
    }

    public ArrayList<Point> getHiPoint(){
        return mHiPoint;
    }
    public ArrayList<Point> getHiSize(){
        return mHiSize;
    }
}
